---
title: FileSystemEntry.toURL()
slug: Web/API/FileSystemEntry/toURL
tags:
  - API
  - File System API
  - File and Directory Entries API
  - FileSystemEntry
  - Files
  - Method
  - Non-standard
  - Reference
  - toURL
---
<p>{{APIRef("File System API")}}{{Obsolete_Header}}</p>

<p><span class="seoSummary">The {{domxref("FileSystemEntry")}} interface's method <code><strong>toURL</strong></code><strong><code>()</code></strong> creates and returns a string containing a URL which can be used to identify the file system entry. This is done by exposing a new URL scheme—<code>filesystem:</code>—that can be used as the value of <code>src</code> and <code>href</code> attributes.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>FileSystemEntry</em>.toURL([<em>mimeType</em>]);</pre>

<h3 class="syntaxbox" id="Parameters">Parameters</h3>

<dl>
 <dt><code>mimeType</code> {{optional_inline}}</dt>
 <dd>An optional string specifying the MIME type to use when interpreting the file. This can be used to help deal with files whose types aren't recognized automatically by the user agent. If this parameter is omitted, the user agent uses its standard algorithms to identify the file.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("DOMString")}} containing a URL that can then be used as a document reference in HTML content, or an empty string if the URL can't be generated (such as if the file system implementation doesn't support <code>toURL()</code>).</p>

<h2 id="Example">Example</h2>

<p>If you have a {{domxref("FileSystemFileEntry")}} corresponding to an image file in a file system available to your Web site or app, you can call <code>toURL()</code> to get its URL for use in HTML. If your site is located at <code>http://my-awesome-website.woot</code>, and you have a temporary file system that contains an image file named <code>awesomesauce.jpg</code>, the URL returned by <code>toURL()</code> might be (depending on the browser's implementation) something like <code>"filesystem:http://my-awesome-website.woot/temporary/awesomesauce.jpg"</code>.</p>

<p>Code that makes use of this might look like this:</p>

<pre class="brush: js">let img = document.createElement("img");

img.src = imageFileEntry.toURL();
document.body.appendChild(img);</pre>

<p>Assuming the scenario mentioned before the code, the result would be HTML that looks like this being appended to the end of the document:</p>

<pre class="brush: html">&lt;img src="filesystem:http://my-awesome-website.woot/temporary/awesomesauce.jpg"&gt;</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemEntry.toURL")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API/Introduction">Introduction to the File System API</a></li>
 <li>{{domxref("FileSystemDirectoryEntry.removeRecursively()")}}</li>
</ul>
